All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
faiss::IndexFlat1D Struct Reference

optimized version for 1D "vectors" More...

`#include <IndexFlat.h>`

Inheritance diagram for faiss::IndexFlat1D:

## Public Member Functions

| IndexFlat1D (bool continuous_update=true)
void | update_permutation ()
virtual void | add (idx_t n, const float *x) override
virtual void | reset () override
| removes all elements from the database.
virtual void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
| Warn: the distances returned are L1 not L2.
Public Member Functions inherited from faiss::IndexFlatL2
| IndexFlatL2 (idx_t d)
Public Member Functions inherited from faiss::IndexFlat
| IndexFlat (idx_t d, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | set_typename () override
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const override
virtual void | reconstruct (idx_t key, float *recons) const override
void | compute_distance_subset (idx_t n, const float *x, idx_t k, float *distances, const idx_t *labels) const
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | train (idx_t n, const float *x)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
virtual std::string | get_typename () const

## Public Attributes

bool | continuous_update
| is the permutation updated continuously?
std::vector< idx_t > | perm
| sorted database indices
Public Attributes inherited from faiss::IndexFlat
std::vector< float > | xb
| database vectors, size ntotal * d
Public Attributes inherited from faiss::Index
std::string | index_typename
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members

Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

optimized version for 1D "vectors"

Definition at line 142 of file IndexFlat.h.

## Member Function Documentation

void faiss::IndexFlat1D::add | ( | idx_t | n,
|  | const float * | x
| ) |  |

override virtual

Add n vectors of dimension d to the index.

Vectors are implicitly assigned labels ntotal .. ntotal + n - 1 This function slices the input vectors in chuncks smaller than blocksize_add and calls add_core.

Parameters

  x | input matrix, size n * d

Reimplemented from faiss::IndexFlat.

Definition at line 293 of file IndexFlat.cpp.

void faiss::IndexFlat1D::update_permutation | ( |  | ) |

if not continuous_update, call this between the last add and the first search

Definition at line 283 of file IndexFlat.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/IndexFlat.h
- /data/users/matthijs/github_faiss/faiss/IndexFlat.cpp